import { SourceFile, SourceDirectory } from '../sources/index';
import { Reflection, ReflectionKind } from './abstract';
import { ContainerReflection } from './container';
export declare class ProjectReflection extends ContainerReflection {
    reflections: {
        [id: number]: Reflection;
    };
    symbolMapping: {
        [symbolId: number]: number;
    };
    directory: SourceDirectory;
    files: SourceFile[];
    name: string;
    readme?: string;
    packageInfo: any;
    constructor(name: string);
    isProject(): this is ProjectReflection;
    getReflectionsByKind(kind: ReflectionKind): Reflection[];
    findReflectionByName(arg: string | string[]): Reflection | undefined;
    getDanglingReferences(): string[];
}
